<?php
/**
*
* @package - phpbb3 UPS Easy Shop
* @version $Id: user_permission_shop_hangman.php 171 2010-03-10 13:42:11Z femu $
* @copyright (c) Wuerzi (http://spieleresidenz.de), (c) femu (http://die-muellers.org)
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
*
* INSTALLATION   INSTRUCTIONS
*
* You first need to find out, which permission you like to set.
*
* So open your phpMyAdmin and check the table phpbb_acl_users
* and note the ID number of the permission you like to give.
*
* Next step is to modify this file:
*
* 1,	Save this file in root/includes/shop/items with a clear
*	file name like ie. item_perm_play_hangman.php
* 2,	Replace {FILE_NAME} with the name of your saved file name
* 3,	Replace {PERMISSION_NUMBER} with the ID number
*
*/

/*
 * @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class user_permission_shop_hangman extends item
{
	function init()
	{
	}

	function get_actions()
	{
		global $user;

		$actions = array();

		//In most cases, items that have an action with them should use the "use" action.
		//To enable it, uncomment the following code:
		$actions['use'] = array(
			'name'      => $user->lang['SHOP_ITEM_USE'],
			'confirm'   => sprintf($user->lang['SHOP_ITEM_CONFIRM_USE'], $this->data['name']),
			'function'  => 'use_item'
		);

		$actions = array_merge($actions, parent::get_actions());
		return $actions;
	}

	function use_item()
	{
		global $user, $shop, $db, $phpEx, $phpbb_root_path;

		$auth_name = 'u_hangman_play';

		$sql = 'SELECT *
			FROM ' . ACL_OPTIONS_TABLE . '
			WHERE auth_option = "' . $auth_name . '"';
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$auth_id = $row['auth_option_id'];

		if (!$auth_id)
		{
			// Remove item from users inventory
			$this->remove_item();

			// Sorting back the item into the shop
			$sql = 'UPDATE ' . SHOP_ITEMS_TABLE . '
				SET quantity = quantity + 1
				WHERE item=' . (int) $this->data['item'];
			$db->sql_query($sql);

			// Giving back the users points
			$shop->cash->deposit_user($this->data['price']);

			// Inform user
			$meta_info = append_sid("{$phpbb_root_path}shop.$phpEx");
			meta_refresh(3, $meta_info);
			$message = $user->lang['SHOP_OPTION_NOT_EXIST'] . '<br /><br />' . sprintf($user->lang['RETURN_PAGE'], '<a href="' . $meta_info . '">', '</a>');
			trigger_error($message);
			return;
		}

		$auth_setting = 1;

		$isset = $this->isset_acl($auth_id);

		$sql_ary = array(
			'user_id'			=> $user->data['user_id'],
			'auth_option_id'	=> $auth_id,
			'auth_setting'		=> $auth_setting,
		);

		$sql = 'SELECT *
			FROM ' . ACL_USERS_TABLE . '
			WHERE user_id = ' . (int) $user->data['user_id'] . '
				AND auth_option_id = ' . $auth_id;
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);

		if ($isset && $row['auth_setting'] == $auth_setting)
		{
			// Remove item from users inventory
			$this->remove_item();

			// Sorting back the item into the shop
			$sql = 'UPDATE ' . SHOP_ITEMS_TABLE . '
				SET quantity = quantity + 1
				WHERE item=' . (int) $this->data['item'];
			$db->sql_query($sql);

			// Giving back the users points
			$shop->cash->deposit_user($this->data['price']);

			// Notify the user, that he already have the permission
			$meta_info = append_sid("{$phpbb_root_path}shop.$phpEx");
			meta_refresh(3, $meta_info);
			$message = $user->lang['SHOP_ITEM_PERMISSION'] . '<br /><br />' . sprintf($user->lang['RETURN_PAGE'], '<a href="' . $meta_info . '">', '</a>');
			trigger_error($message);
		}
		elseif ($isset && $row['auth_setting'] != $auth_setting)
		{
			// Update the permission, if the user has the permission, but set 0
			$sql = 'UPDATE ' . ACL_USERS_TABLE . '
				SET ' . $db->sql_build_array('UPDATE', $sql_ary) . '
				WHERE user_id = ' . $user->data['user_id'] . '
					AND auth_option_id = ' . $auth_id;
			$db->sql_query($sql);

			$cache->destroy('acl_options');

			$this->remove_item();

			$message = sprintf($user->lang['SHOP_ITEM_NOW_USE'], $this->data['name']);
			return $message;
		}
		else
		{
			// Add the new permission for the user
			$sql = 'INSERT INTO ' . ACL_USERS_TABLE . $db->sql_build_array('INSERT', $sql_ary);
			$db->sql_query($sql);

			$this->remove_item();

			$message = sprintf($user->lang['SHOP_ITEM_NOW_USE'], $this->data['name']);
			return $message;
		}
		$db->sql_freeresult($result);
	}

	function isset_acl($auth_id)
	{
		global $db, $user;

		$sql = 'SELECT COUNT(*) as num
			FROM ' . ACL_USERS_TABLE . '
			WHERE user_id = ' . $user->data['user_id'] . '
			AND auth_option_id = ' . $auth_id;
		$result = $db->sql_query($sql);
		$num = $db->sql_fetchfield('num');
		$db->sql_freeresult($result);

		return $num;
	}
}

?>
