<?php
/**
*
* @package - phpbb3 UPS Easy Shop
* @version $Id$
* @copyright (c) Wuerzi (http://spieleresidenz.de), (c) femu (http://die-muellers.org)
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
*
* INSTALLATION   INSTRUCTIONS
* 
* You first need to find out, which permission you like to set.
* 
* The permissions are normaly found in the language folders. So the main permission
* file can be found in language/xx/acp/permissions_phpbb.php. Use then the
* permission without the leading acl_ !
*
* Permissions comming with modifications, are normally held in the folder
* language/xx/mods and looks like permissions_xxx.php. Some mod authors place them
* in their normal language files. So you might need to check these too.  The permissions
* will look like:
*
* acl_u_xxxx / acl_m_xxxx / acl_a_xxxx
*
* u_ is for user permission, m_ for moderator permission and a_ for admin permission.
* 
* Note the desired permission WITHOUT the leading acl_ !!!
* 
* Next step is to modify this file:
* 
* 1,	Save this file in root/includes/shop/items with a clear 
*	file name like ie. item_perm_play_hangman.php
* 2,	Replace FILE_NAME with the same name of your saved file name
* 3,	Replace AUTH_NAME with the auth name, you like to use
* 
* DO NOT CHANGE ANYTHING ELSE !!!!
*/

/*
 * @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* USER ACTION
* =============
* Change here the name to the selected filename
* i.e. class item_permission_example
*/

class FILE_NAME extends item
{
	function init()
	{
	}

	function get_actions()
	{
		global $user;

		$actions = array();

/**	
*	In most cases, items that have an action with them should use the "use" action.
*	To enable it, uncomment the following code:
*/
		$actions['use'] = array(
			'name'      => $user->lang['SHOP_ITEM_USE'],
			'confirm'   => sprintf($user->lang['SHOP_ITEM_CONFIRM_USE'], $this->data['name']),
			'function'  => 'use_item'
		);

		$actions = array_merge($actions, parent::get_actions());
		return $actions;
	}

	function use_item()
	{
		global $user, $shop, $db, $phpEx, $phpbb_root_path;

/**	
* USER ACTION
* =============
* Replace below the AUTH_NAME between the apostrophs with the permission name
* ie. u_hangman_play
*/
		$auth_name = 'AUTH_NAME';

		$sql = 'SELECT *
			FROM ' . ACL_OPTIONS_TABLE . '
			WHERE auth_option = "' . $auth_name . '"';
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$auth_id = $row['auth_option_id'];

		if (!$auth_id)
		{
			// Remove item from users inventory
			$this->remove_item();

			// Sorting back the item into the shop
			$sql = 'UPDATE ' . SHOP_ITEMS_TABLE . '
				SET quantity = quantity + 1
				WHERE item=' . (int) $this->data['item'];
			$db->sql_query($sql);

			// Giving back the users points
			$shop->cash->deposit_user($this->data['price']);

			// Inform user
			$meta_info = append_sid("{$phpbb_root_path}shop.$phpEx");
			meta_refresh(3, $meta_info);
			$message = $user->lang['SHOP_OPTION_NOT_EXIST'] . '<br /><br />' . sprintf($user->lang['RETURN_PAGE'], '<a href="' . $meta_info . '">', '</a>');
			trigger_error($message);
			return;
		}

		$message = '';
		$auth_setting = 1;

		$isset = $this->isset_acl($auth_id);

		$sql_ary = array(
			'user_id'			=> $user->data['user_id'],
			'auth_option_id'	=> $auth_id,
			'auth_setting'		=> $auth_setting,
		);

		$sql = 'SELECT *
			FROM ' . ACL_USERS_TABLE . '
			WHERE user_id = ' . (int) $user->data['user_id'] . '
				AND auth_option_id = ' . $auth_id;
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);

		if ($isset && $row['auth_setting'] == $auth_setting)
		{
			// Remove item from users inventory
			$this->remove_item();

			// Sorting back the item into the shop
			$sql = 'UPDATE ' . SHOP_ITEMS_TABLE . '
				SET quantity = quantity + 1
				WHERE item=' . (int) $this->data['item'];
			$db->sql_query($sql);

			// Giving back the users points
			$shop->cash->deposit_user($this->data['price']);

			// Notify the user, that he already have the permission
			$meta_info = append_sid("{$phpbb_root_path}shop.$phpEx");
			meta_refresh(3, $meta_info);
			$message = $message . $user->lang['SHOP_ITEM_PERMISSION'] . '<br /><br />' . sprintf($user->lang['RETURN_PAGE'], '<a href="' . $meta_info . '">', '</a>');
			trigger_error($message);
		}
		elseif ($isset && $row['auth_setting'] != $auth_setting)
		{
			// Update the permission, if the user has the permission, but set 0
			$sql = 'UPDATE ' . ACL_USERS_TABLE . '
				SET ' . $db->sql_build_array('UPDATE', $sql_ary) . '
				WHERE user_id = ' . $user->data['user_id'] . '
					AND auth_option_id = ' . $auth_id;
			$db->sql_query($sql);

			$this->remove_item();

			$message = sprintf($user->lang['SHOP_ITEM_NOW_USE'], $this->data['name']);
			return $message;		
		}
		else
		{
			// Add the new permission for the user
			$sql = 'INSERT INTO ' . ACL_USERS_TABLE . $db->sql_build_array('INSERT', $sql_ary);
			$db->sql_query($sql);

			$cache->destroy('acl_options');

			$this->remove_item();

			$message = sprintf($user->lang['SHOP_ITEM_NOW_USE'], $this->data['name']);
			return $message;
		}
		$db->sql_freeresult($result);
	}

	function isset_acl($auth_id)
	{
		global $db, $user;

		$sql = 'SELECT COUNT(*) as num 
			FROM ' . ACL_USERS_TABLE . '
			WHERE user_id = ' . $user->data['user_id'] . '
			AND auth_option_id = ' . $auth_id;
		$result = $db->sql_query($sql);
		$num = $db->sql_fetchfield('num');
		$db->sql_freeresult($result);

		return $num;
	}
}

?>
