<?php
/**
*
* @package - phpbb3 UPS Easy Shop
* @version $Id: acp_shop_mod.php 270 2010-08-30 12:53:10Z femu $
* @copyright (c) 2010 Wuerzi - http://spieleresidenz.de and femu - http://die-muellers.org
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/*
 * @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package acp
*/
class acp_shop_mod
{
	var $u_action;

	function items()
	{
		global $db, $user, $auth, $template;
		global $config, $phpbb_root_path, $phpbb_admin_path, $phpEx, $shop;

		// Set up general vars
		$submit 	= request_var('submit', '');
		$action 	= request_var('action', '');

		add_form_key('acp_shop');

		$this->page_title 	= 'ACP_SHOP_ITEMS';

		switch ($action)
		{
			case 'edit':

			case 'add':
				$display_vars = array(
					'title'	=> ($action == 'edit') ? 'ACP_SHOP_EDIT_ITEM' : 'ACP_SHOP_ADD_ITEM',
					'vars'	=> array(
						'legend1'			=> 'ACP_SHOP_ITEM_SETTINGS',
						'name'				=> array('lang' => 'ACP_SHOP_ITEM_NAME',			'validate' => 'string',		'type' => 'text:30:100', 'explain' => true),
						'description'		=> array('lang' => 'ACP_SHOP_ITEM_DESCRIPTION',		'validate' => 'string',		'type' => 'text:50:255', 'explain' => true),
						'backend'			=> array('lang' => 'ACP_SHOP_ITEM_BACKEND',			'validate' => 'string',		'type' => 'select', 'method' => 'backend_select', 'explain' => true),
						'icon'				=> array('lang' => 'ACP_SHOP_ITEM_ICON',			'validate' => 'string',		'type' => 'select', 'method' => 'icon_select', 'explain' => true),
						'shop_cat_id'		=> array('lang' => 'ACP_SHOP_ITEM_CAT',				'validate' => 'int',		'type' => 'select', 'method' => 'item_cat_select', 'explain' => true),
						'price'				=> array('lang' => 'ACP_SHOP_ITEM_PRICE',			'validate' => 'dez',		'type' => 'text:10:10', 'explain' => true, 'append' => ' ' . $config['points_name']),
						'sell_price'		=> array('lang' => 'ACP_SHOP_ITEM_SELL_PRICE',		'validate' => 'dez',		'type' => 'text:10:10', 'explain' => true, 'append' => ' ' . $config['points_name']),
						'quantity'			=> array('lang' => 'ACP_SHOP_ITEM_QUANTITY',		'validate' => 'int',		'type' => 'text:10:5',	'explain' => true),
						'auto_refill'		=> array('lang' => 'ACP_SHOP_AUTO_REFILL',			'validate' => 'bool',		'type' => 'radio:yes_no', 'explain' => true),
						'auto_refill_min'	=> array('lang' => 'ACP_SHOP_AUTO_REFILL_MIN',		'validate' => 'int',		'type' => 'text:10:5', 'explain' => true),
						'auto_refill_qty'	=> array('lang' => 'ACP_SHOP_AUTO_REFILL_QTY',		'validate' => 'int',		'type' => 'text:10:5', 'explain' => true),
						'max_per_user'		=> array('lang' => 'ACP_SHOP_MAX_PER_USER',			'validate' => 'int',		'type' => 'text:10:5', 'explain' => true),
						'can_trash'			=> array('lang' => 'ACP_SHOP_TRASHABLE',			'validate' => 'bool',		'type' => 'radio:yes_no', 'explain' => true),
						'can_sellback'		=> array('lang' => 'ACP_SHOP_SELLABLE',				'validate' => 'bool',		'type' => 'radio:yes_no', 'explain' => true),
						'instant_use'		=> array('lang' => 'ACP_SHOP_INSTANT_USE',			'validate' => 'bool',		'type' => 'radio:yes_no', 'explain' => true),
						'can_display'		=> array('lang' => 'ACP_SHOP_CAN_DISPLAY',			'validate' => 'bool',		'type' => 'radio:yes_no', 'explain' => true),
				));

				if ($action == 'edit')
				{
					$item_id = request_var('item', 0);

					if (!$item = $shop->get_item($item_id))
					{
						trigger_error($user->lang['ACP_SHOP_ID_NOT_FOUND'], E_USER_ERROR);
					}
					$this->new_config = $item->data;
				}
				else
				{
					$this->new_config = array(
						'name' 			=> '',
						'description' 	=> '',
						'backend' 		=> 'blank',
						'icon' 			=> '',
						'price' 		=> '1.00',
						'sell_price' 	=> '1.00',
						'quantity' 		=> '1',
						'can_trash'		=> '0',
						'can_sellback'	=> '0',
						'instant_use'	=> '0',
						'can_display'	=> '0',
						'shop_cat_id'	=> '0'
					);
				}

				$cfg_array = (isset($_REQUEST['config'])) ? utf8_normalize_nfc(request_var('config', array('' => ''), true)) : $this->new_config;

				$error = array();

				// We validate the complete config if whished
				validate_config_vars($display_vars['vars'], $cfg_array, $error);

				foreach ($display_vars['vars'] as $config_name => $null)
				{
					if (!isset($cfg_array[$config_name]) || strpos($config_name, 'legend') !== false)
					{
						continue;
					}
					$this->new_config[$config_name] = $cfg_array[$config_name];
				}

				if ($submit)
				{
					//ask for confirmation if they changed the backend
					if ($action == 'edit' && $this->new_config['backend'] != $item->data['backend'])
					{
						if (!confirm_box(true))
						{
							foreach ($cfg_array as $key => $value)
							{
								$s_hidden_fields["config[$key]"] = $value;
							}

							$s_hidden_fields['submit'] = true;
							$s_hidden_fields = build_hidden_fields($s_hidden_fields);
							confirm_box(false, $user->lang['ACP_SHOP_BACKEND_CHANGE'], $s_hidden_fields);
						}
					}

					if ($submit && !check_form_key('acp_shop') && !confirm_box(true))
					{
						trigger_error($user->lang['FORM_INVALID'] . adm_back_link($this->u_action), E_USER_WARNING);
					}

					// Figure out the height and width of the icon
					if ($this->new_config['icon'] != '0')
					{
						$img_path = 'images/shop_icons/';
						$img_size = getimagesize($phpbb_root_path . $img_path . '/' . $this->new_config['icon']);
						$this->new_config['icon_width'] = $img_size[0];
						$this->new_config['icon_height'] = $img_size[1];
					}
					else
					{
						$this->new_config['icon_width'] = 0;
						$this->new_config['icon_height'] = 0;
					}

					if ($action == 'edit')
					{
						$sql = 'UPDATE ' . SHOP_ITEMS_TABLE . '
							SET ' . $db->sql_build_array('UPDATE', $this->new_config) . '
							WHERE item = ' . $item_id;
						$db->sql_query($sql);

						add_log('admin', 'LOG_SHOP_ITEM_UPDATE');
						trigger_error($user->lang['ACP_SHOP_ITEM_UPDATED'] . adm_back_link($this->u_action));
					}
					else
					{
						// Figure out order id
						$sql = 'SELECT max(item_order) AS item_order
							FROM '. SHOP_ITEMS_TABLE;
						$result = $db->sql_query($sql);

						if ($db->sql_affectedrows($result) == 1)
						{
							$data = $db->sql_fetchrow($result);
							$this->new_config['item_order'] = $data['item_order'] + 1;
						}
						else
						{
							$this->new_config['item_order'] = 1;
						}

						$sql = 'INSERT INTO ' . SHOP_ITEMS_TABLE . ' ' . $db->sql_build_array('INSERT', $this->new_config);
						$db->sql_query($sql);

						add_log('admin', 'LOG_SHOP_ITEM_ADD');
						trigger_error($user->lang['ACP_SHOP_ITEM_ADDED'] . adm_back_link($this->u_action));
					}
				}

				if ($action == 'edit')
				{
					$this->u_action .= '&amp;action=edit&amp;item=' . $item_id;
				}
				else
				{
					$this->u_action .= '&amp;action=add';
				}

				$template->assign_vars(array(
					'L_TITLE'			=> $user->lang[$display_vars['title']],
					'L_TITLE_EXPLAIN'	=> $user->lang['ACP_SHOP_ITEM_MAN_EXPLAIN'],
					'S_ERROR'			=> (sizeof($error)) ? true : false,
					'ERROR_MSG'			=> implode('<br />', $error),

					'U_ACTION'			=> $this->u_action,
					'S_EDIT'			=> true,
				));

				// Output relevant page
				foreach ($display_vars['vars'] as $config_key => $vars)
				{
					if (!is_array($vars) && strpos($config_key, 'legend') === false)
					{
						continue;
					}

					if (strpos($config_key, 'legend') !== false)
					{
						$template->assign_block_vars('options', array(
							'S_LEGEND'	=> true,
							'LEGEND'	=> (isset($user->lang[$vars])) ? $user->lang[$vars] : $vars)
						);
						continue;
					}

					$type = explode(':', $vars['type']);

					$l_explain = '';
					if ($vars['explain'] && isset($vars['lang_explain']))
					{
						$l_explain = (isset($user->lang[$vars['lang_explain']])) ? $user->lang[$vars['lang_explain']] : $vars['lang_explain'];
					}
					else if ( $vars['explain'] )
					{
						$l_explain = (isset($user->lang[$vars['lang'] . '_EXPLAIN'])) ? $user->lang[$vars['lang'] . '_EXPLAIN'] : '';
					}

					$content = build_cfg_template($type, $config_key, $this->new_config, $config_key, $vars);

					if (empty($content))
					{
						continue;
					}

					$template->assign_block_vars('options', array(
						'KEY'			=> $config_key,
						'TITLE'			=> (isset($user->lang[$vars['lang']])) ? $user->lang[$vars['lang']] : $vars['lang'],
						'S_EXPLAIN'		=> $vars['explain'],
						'TITLE_EXPLAIN'	=> $l_explain,
						'CONTENT'		=> $content,
						)
					);

					unset($display_vars['vars'][$config_key]);
				}
				return;
			break;

			case 'delete':

				$item_id = request_var('item', 0);

				if (!$item = $shop->get_item($item_id))
				{
					trigger_error($user->lang['ACP_SHOP_ID_NOT_FOUND'], E_USER_ERROR);
				}

				if (confirm_box(true))
				{
					$sql = 'SELECT u.*, i.*
						FROM ' . SHOP_ITEMS_USER_TABLE . ' u
						LEFT JOIN ' . SHOP_ITEMS_TABLE . ' i
							ON u.item = i.item
						WHERE u.item = ' . $item_id;
					$result = $db->sql_query($sql);

					while ($row = $db->sql_fetchrow($result))
					{
						$pay_back_user = $row['user'];
						$pay_back = $row['price'] * $row['quantity_user'];

						$sql = 'UPDATE ' . USERS_TABLE . '
							SET user_points = user_points + ' . $pay_back . '
							WHERE user_id = ' . $pay_back_user;
						$db->sql_query($sql);
					}
					$db->sql_freeresult($result);

					$sql = 'DELETE FROM ' . SHOP_ITEMS_TABLE . '
						WHERE item = ' . $item_id;
					$db->sql_query($sql);

					$sql = 'DELETE FROM ' . SHOP_ITEMS_USER_TABLE . '
						WHERE item = ' . $item_id;
					$db->sql_query($sql);

					trigger_error($user->lang['ACP_SHOP_ITEM_DELETED'] . adm_back_link($this->u_action));
				}
				else
				{
					$confirm_string = sprintf($user->lang['ACP_SHOP_ITEM_CONFIRM_DELETE'], $item->data['name']);
					confirm_box(false, $confirm_string);
				}

			break;

			case 'move_up':
			case 'move_down':
				$item_id = request_var('item', 0);

				// Get current order id...
				$sql = 'SELECT item_order
					FROM ' . SHOP_ITEMS_TABLE . '
					WHERE item = ' . $item_id;
				$result = $db->sql_query($sql);
				$current_order = (int) $db->sql_fetchfield('item_order');
				$db->sql_freeresult($result);

				if ($current_order == 0 && $action == 'move_up')
				{
					break;
				}

				// on move_down, switch position with next order_id...
				// on move_up, switch position with previous order_id...
				$switch_order_id = ($action == 'move_down') ? $current_order + 1 : $current_order - 1;

				$sql = 'UPDATE ' . SHOP_ITEMS_TABLE . "
					SET item_order = $current_order
					WHERE item_order = $switch_order_id
						AND item <> $item_id";
				$db->sql_query($sql);

				// Only update the other entry too if the previous entry got updated
				if ($db->sql_affectedrows())
				{
					$sql = 'UPDATE ' . SHOP_ITEMS_TABLE . "
						SET item_order = $switch_order_id
						WHERE item_order = $current_order
							AND item = $item_id";
					$db->sql_query($sql);
				}
			break;
		}


		// By default, check that item_order is valid and fix it if necessary
		// this fun snippet of code stolen from acp_icons.php
		$sql = 'SELECT item, item_order
			FROM ' . SHOP_ITEMS_TABLE . '
			ORDER BY item_order';
		$result = $db->sql_query($sql);

		if ($row = $db->sql_fetchrow($result))
		{
			$order = 0;
			do
			{
				++$order;
				if ( $row['item_order'] != $order )
				{
					$db->sql_query('UPDATE ' . SHOP_ITEMS_TABLE . "
						SET item_order = $order
						WHERE item = " . $row['item']);
				}
			}
			while ($row = $db->sql_fetchrow($result));
		}
		$db->sql_freeresult($result);

		// Display the list of items
		$template->assign_vars(array(
			'S_SUBMIT'	=> $this->u_action,
			'S_ITEMS'	=> true,
			'U_ACTION'	=> $this->u_action . '&amp;action=add',
		));

		// Pagination Items
		$sql = 'SELECT config_name, config_value
			FROM ' . SHOP_CONFIG_TABLE;
		$result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result))
		{
			$shop_config[$row['config_name']] = $row['config_value'];
		}
		$db->sql_freeresult($result);

		$pagination_start	= request_var('start', 0);
		$number				= $shop_config['items_per_page'];

		$sql = 'SELECT COUNT(item) AS total_items
			FROM ' . SHOP_ITEMS_TABLE . '
			WHERE item > 0 ';
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$total_items = $row['total_items'];
		$db->sql_freeresult($result);

		if ($items = $shop->get_item_list_acp())
		{
			foreach ($items as $item)
			{
				$icon_show_width = $icon_show_height = 0;
				$sql = 'SELECT cat_name
					FROM ' . SHOP_CATS_TABLE . '
					WHERE cat_id = ' . $item->data['shop_cat_id'];
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$cat_name = $row['cat_name'];

				// Define image size and scale ratio
				// Code partly from Michael Bailey
				$orig_width = $item->data['icon_width'];
				$orig_height = $item->data['icon_height'];
				$scale = min($shop_config['shop_icon_width']/$orig_width, $shop_config['shop_icon_height']/$orig_height);

				// If the image is larger than the max shrink it
				if ($scale < 1)
				{
					$icon_show_width = floor($scale*$orig_width);
					$icon_show_height = floor($scale*$orig_height);
				}
				else
				{
					$icon_show_width = $orig_width;
					$icon_show_height = $orig_height;
				}

				// Show the full size icon in a seperate tab
				$show_icon = '<a href="' . $phpbb_root_path . 'images/shop_icons/' . $item->data['icon'] . '" onclick="window.open(this.href); return false" title="' . $user->lang['ACP_SHOP_ICON_CLICK'] . '"><img src="' . $phpbb_root_path . 'images/shop_icons/' . $item->data['icon'] . '" width="' . $icon_show_width . '" height="' . $icon_show_height . '" alt="' . $user->lang['ACP_SHOP_ICON_CLICK'] . '" /></a>';

				$template->assign_block_vars('items', array(
					'NAME'			=> $item->data['name'],
					'CAT'			=> $cat_name,
					'QUANTITY'		=> $item->data['quantity'],
					'ICON'			=> $show_icon,
					'U_EDIT'		=> $this->u_action . '&amp;action=edit&amp;item=' . $item->data['item'],
					'U_DELETE'		=> $this->u_action . '&amp;action=delete&amp;item=' . $item->data['item'],
					'U_MOVE_UP'		=> $this->u_action . '&amp;action=move_up&amp;item=' . $item->data['item'] . '&amp;start=' . $pagination_start,
					'U_MOVE_DOWN'	=> $this->u_action . '&amp;action=move_down&amp;item=' . $item->data['item'] . '&amp;start=' . $pagination_start,
				));
			}
		}

		$template->assign_vars(array(
			'PAGINATION' 		=> generate_pagination($this->u_action, $total_items, $number, $pagination_start, true),
			'PAGE_NUMBER'		=> on_page($total_items, $number, $pagination_start),
			'TOTAL_ITEMS'		=> ($total_items == 1) ? $user->lang['ACP_SHOP_SINGLE'] : sprintf($user->lang['ACP_SHOP_MULTI'], $total_items),
		));
	}

	function config()
	{
		global $db, $user, $auth, $template;
		global $config, $phpbb_root_path, $phpbb_admin_path, $phpEx, $shop, $shop_config;

		// Read out config data
		$sql = 'SELECT config_name, config_value
			FROM ' . SHOP_CONFIG_TABLE;
		$result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result))
		{
			$shop_config[$row['config_name']] = $row['config_value'];
		}
		$db->sql_freeresult($result);

		$template->assign_vars(array_change_key_case($shop_config, CASE_UPPER));

		// Set up general vars
		$submit = request_var('submit', '');
		$action = request_var('actions', '');

		add_form_key('acp_shop');

		$this->page_title 	= 'ACP_SHOP_CONFIG';

		if ($submit)
		{
			if (!check_form_key('acp_shop'))
			{
				trigger_error($user->lang['FORM_INVALID'] . adm_back_link($this->u_action), E_USER_WARNING);
			}

			$shop_name				= utf8_normalize_nfc(request_var('shop_name', '', true));
			$shop_enable			= request_var('shop_enable', 0);
			$shop_disable_message	= utf8_normalize_nfc(request_var('disable_message', '', true));
			$shop_shelf_size_sig	= request_var('shop_shelf_size_sig', 0);
			$items_per_page			= request_var('items_per_page', 0);
			$shop_pm_on_buy			= request_var('shop_pm_on_buy', 0);
			$shop_pm_admin			= request_var('shop_pm_admin', 0);
			$shop_items_viewtopic	= request_var('shop_items_viewtopic', 0);
			$shop_items_profile		= request_var('shop_items_profile', 0);
			$shop_icon_height		= request_var('shop_icon_height', 0);
			$shop_icon_width		= request_var('shop_icon_width', 0);
			$shop_log_user_activity	= request_var('shop_log_user_activity', 0);

			if ($shop_name != $config['shop_name'])
			{
				set_config('shop_name', $shop_name);
			}

			if ($shop_enable != $config['shop_enable'])
			{
				set_config('shop_enable', $shop_enable);
			}

			if ($shop_disable_message != $shop_config['disable_message'])
			{
				set_shop_config('disable_message', $shop_disable_message);
			}

			if ($shop_shelf_size_sig != $config['shop_shelf_size_sig'])
			{
				set_config('shop_shelf_size_sig', $shop_shelf_size_sig);
			}

			if ($items_per_page != $shop_config['items_per_page'])
			{
				set_shop_config('items_per_page', $items_per_page);
			}

			if ($shop_pm_on_buy != $shop_config['shop_pm_on_buy'])
			{
				set_shop_config('shop_pm_on_buy', $shop_pm_on_buy);
			}

			if ($shop_pm_admin != $shop_config['shop_pm_admin'])
			{
				set_shop_config('shop_pm_admin', $shop_pm_admin);
			}

			if ($shop_items_viewtopic != $shop_config['shop_items_viewtopic'])
			{
				set_shop_config('shop_items_viewtopic', $shop_items_viewtopic);
			}

			if ($shop_items_profile != $shop_config['shop_items_profile'])
			{
				set_shop_config('shop_items_profile', $shop_items_profile);
			}

			if ($shop_icon_height != $shop_config['shop_icon_height'])
			{
				set_shop_config('shop_icon_height', $shop_icon_height);
			}

			if ($shop_icon_width != $shop_config['shop_icon_width'])
			{
				set_shop_config('shop_icon_width', $shop_icon_width);
			}

			if ($shop_log_user_activity != $shop_config['shop_log_user_activity'])
			{
				set_shop_config('shop_log_user_activity', $shop_log_user_activity);
			}

			add_log('admin', 'LOG_CONFIG_SHOP');
			trigger_error($user->lang['CONFIG_UPDATED'] . adm_back_link($this->u_action));
		}
		else
		{
			$sql = 'SELECT user_id, username
				FROM ' . USERS_TABLE . '
				WHERE user_id = ' . $shop_config['shop_pm_admin'];
			$result = $db->sql_query_limit($sql, 1);
			$row = $db->sql_fetchrow($result);
			$db->sql_freeresult($result);

			$template->assign_vars(array(
				'SHOP_ENABLE'				=> ($config['shop_enable']) ? true : false,
				'SHOP_DISABLE_MESSAGE'		=> $shop_config['disable_message'],
				'ITEMS_PER_PAGE'			=> $shop_config['items_per_page'],
				'SHOP_PM_ON_BUY'			=> ($shop_config['shop_pm_on_buy']) ? true : false,
				'SHOP_PM_ADMIN'				=> $shop_config['shop_pm_admin'],
				'SHOP_PM_ADMIN_NAME'		=> $row['username'],
				'SHOP_NAME'					=> $config['shop_name'],
				'MAX_ITEMS_SHELF'			=> $config['shop_shelf_size_sig'],
				'SHOP_ICON_HEIGHT'			=> $shop_config['shop_icon_height'],
				'SHOP_ICON_WIDTH'			=> $shop_config['shop_icon_width'],
				'SHOP_LOG_USER_ACTIVITY'	=> $shop_config['shop_log_user_activity'],
			));
		}

		if ($submit)
		{
			// If the size of the shelf was decreased, we need to remove excess items
			if ($config_name == 'shop_shelf_size_sig' && $config['shop_shelf_size_sig'] > $config_value)
			{
				// Get a list of all users
				$sql = 'SELECT user_id
					FROM ' . USERS_TABLE;
				$result = $db->sql_query($sql);

				while ($row = $db->sql_fetchrow($result))
				{
					$items = $shop->get_item_list_user($row['user_id'], 'shelf_display = 1');

					if ( $items && sizeof($items) > $config_value )
					{
						for ($i = sizeof($items); $i > $config_value; $i--)
						{
							$items[$i - 1]->display();
						}
					}
				}
			}
			set_config($config_name, $config_value);
		}

		$template->assign_vars(array(
			'U_ACTION'			=> $this->u_action,
			'S_CONFIG'			=> true,
		));

	}

	function main($id, $mode)
	{
		global $db, $user, $auth, $template;
		global $config, $phpbb_root_path, $phpbb_admin_path, $phpEx, $shop;

		// Include shop functions
		require($phpbb_root_path . 'includes/shop/functions_shop.' . $phpEx);
		$shop = new shop;

		// Set up the page
		$this->tpl_name 	= 'acp_shop_mod';

		$action = request_var('action', '');
		$id		= request_var('id', 0);
		$form_action = $this->u_action. '&amp;action=add';
		$lang_mode = $user->lang['ACP_SHOP_ADD_NEW_CAT'];

		$template->assign_vars(array(
			'BASE'		=> $this->u_action,
		));
		switch ($mode)
		{
			// Set the main switch for managing categories
			case 'manage_categories':
				$this->page_title = 'ACP_SHOP_CATEGORIES';
				$this->tpl_name = 'acp_shop_mod';

				// Now let's define, what to do within the module Manage Categories
				switch ($action)
				{
					// Create a new category
					case 'create':
						$title = 'ACP_SHOP_CREATE_CATEGORY';
						$this->page_title = $user->lang[$title];

						$this->create_cat();
					break;

					// Edit an existing category
					case 'edit':
						$title = 'ACP_SHOP_EDIT_CATEGORY';
						$this->page_title = $user->lang[$title];

						$this->edit_cat();
					break;

					// Delete an existing category
					case 'delete':
						$title = 'ACP_SHOP_DELETE_CATEGORY';
						$this->page_title = $user->lang[$title];

						$this->delete_cat();
					break;

					// Move a category to another position
					case 'move':
						$this->move_cat();
					break;

					// Call the main module
					default:
						$title = 'ACP_SHOP_CATEGORIES';
						$this->page_title = $user->lang[$title];

						$this->manage_cats();
					break;
				}
			break;

			case 'items':
				$this->items();
			break;

			case 'config':
				$this->config();
			break;

			default:
				trigger_error('NO_MODE', E_USER_ERROR);
			break;
		}
	}


	function backend_select($value, $key = '')
	{
		global $phpbb_root_path, $phpEx;

		// Get list of backends
		$itempath = 'includes/shop/items/';
		$backendlist = filelist($phpbb_root_path . $itempath, '', $phpEx);

		// We ensure that the 'blank' backend is the first listed
		$backend_return = '<option value="blank"' . (($value == 'blank') ? ' selected="selected"' : '')  . '>------</option>';
		foreach ($backendlist as $path => $backend_ary)
		{
			asort($backend_ary);

			foreach ($backend_ary as $backend)
			{
				$backend = preg_replace('/\.\w*$/', '', $backend); //chop of the extension

				if ($path . $backend == 'blank')
				{
					continue;
				}

				$backend_return .= '<option value="' . $path . $backend . '"' . (($value == $path . $backend) ? ' selected="selected"' : '')  . '>' . $path . $backend . '</option>';
			}
		}
		return $backend_return;
	}

	function icon_select($value, $key = '')
	{
		global $phpbb_root_path;

		// Get list of icons
		$img_path = 'images/shop_icons/';
		$imglist = filelist($phpbb_root_path . $img_path, '');
		$icon_return = '';

		foreach ($imglist as $path => $img_ary)
		{
			asort($img_ary);

			foreach ($img_ary as $img)
			{
				$icon_return .= '<option value="' . $path . $img . '"' . (($value == $path . $img) ? ' selected="selected"' : '')  . '>' . $path . $img . '</option>';
			}
		}
		return $icon_return;
	}

	function item_cat_select($value, $key = '')
	{
		global $phpbb_root_path, $db, $template;

		$id = request_var('item', 0);

		// Check if there are any categories
		$sql = 'SELECT COUNT(cat_id) AS total_cats
			FROM ' . SHOP_CATS_TABLE;
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$total_cats = $row['total_cats'];
		$db->sql_freeresult($result);

		if ( $total_cats <= 0 )
		{
			trigger_error($user->lang['ACP_SHOP_NO_CAT'] . adm_back_link($this->u_action), E_USER_WARNING);
		}

		$sql = 'SELECT i.*, c.*
			FROM ' . SHOP_ITEMS_TABLE . ' i
				LEFT JOIN ' . SHOP_CATS_TABLE . ' c
				ON i.shop_cat_id = c.cat_id
			WHERE i.item = ' . $id;
		$result = $db->sql_query_limit($sql,1);
		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);

		$sql = 'SELECT *
			FROM ' . SHOP_CATS_TABLE . '
			ORDER BY LOWER(cat_name)';
		$result = $db->sql_query($sql);

		$cats = array();
		while ($row2 = $db->sql_fetchrow($result))
		{
			$cats[$row2['cat_id']] = array(
				'cat_title'	=> $row2['cat_name'],
				'cat_id'	=> $row2['cat_id'],
			);
		}
		$db->sql_freeresult($result);

		$cat_options = '';
		foreach($cats as $key => $value)
		{
			if ($key == $row['shop_cat_id'])
			{
				$cat_options .= '<option value="' . $value['cat_id'] . '" selected="selected">' . $value['cat_title'] . '</option>';
			}
			else
			{
				$cat_options .= '<option value="' . $value['cat_id'] . '">' . $value['cat_title'] . '</option>';
			}
		}
		return $cat_options;
	}

	function manage_cats()
	{
		global $db, $user, $auth, $template, $cache;
		global $config, $phpbb_admin_path, $phpbb_root_path, $phpEx;
		$catrow = array();
		$parent_id = request_var('parent_id', 0);

		$template->assign_vars(array(
			'S_MODE_MANAGE_CAT'	=> true,
			'S_ACTION'		=> $this->u_action . '&amp;action=create&amp;parent_id=' . $parent_id,
		));

		if (!$parent_id)
		{
			$navigation = $user->lang['ACP_SHOP'];
		}
		else
		{
			$navigation = '<a href="' . $this->u_action . '">' . $user->lang['ACP_SHOP'] . '</a>';

			$shop_nav = $this->get_cat_branch($parent_id, 'parents', 'descending');

			foreach ($shop_nav as $row)
			{
				if ($row['cat_id'] == $parent_id)
				{
					$navigation .= ' -&gt; ' . $row['cat_name'];
				}
				else
				{
					$navigation .= ' -&gt; <a href="' . $this->u_action . '&amp;parent_id=' . $row['cat_id'] . '">' . $row['cat_name'] . '</a>';
				}
			}
		}
		$shop = array();
		$sql = 'SELECT *
			FROM ' . SHOP_CATS_TABLE . '
			WHERE parent_id = ' . $parent_id . '
			ORDER BY left_id ASC';
		$result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result))
		{
			$shop[] = $row;
		}

		for( $i = 0; $i < count($shop); $i++ )
		{
			$folder_image = ($shop[$i]['left_id'] + 1 != $shop[$i]['right_id']) ? '<img src="images/icon_subfolder.gif" alt="' . $user->lang['SUBFORUM'] . '" />' : '<img src="images/icon_folder.gif" alt="' . $user->lang['FOLDER'] . '" />';
			$template->assign_block_vars('catrow', array(
				'FOLDER_IMAGE'			=> $folder_image,
				'U_CAT'					=> $this->u_action . '&amp;parent_id=' . $shop[$i]['cat_id'],
				'CAT_NAME'				=> $shop[$i]['cat_name'],
				'CAT_DESCRIPTION'		=> generate_text_for_display($shop[$i]['cat_desc'], $shop[$i]['cat_desc_uid'], $shop[$i]['cat_desc_bitfield'], $shop[$i]['cat_desc_options']),
				'U_MOVE_UP'				=> $this->u_action . '&amp;action=move&amp;move=move_up&amp;cat_id=' . $shop[$i]['cat_id'],
				'U_MOVE_DOWN'			=> $this->u_action . '&amp;action=move&amp;move=move_down&amp;cat_id=' . $shop[$i]['cat_id'],
				'U_EDIT'				=> $this->u_action . '&amp;action=edit&amp;cat_id=' . $shop[$i]['cat_id'],
				'U_DELETE'				=> $this->u_action . '&amp;action=delete&amp;cat_id=' . $shop[$i]['cat_id'],
			));
		}
		$template->assign_vars(array(
			'NAVIGATION'		=> $navigation,
			'S_SHOP'			=> $parent_id,
			'U_EDIT'			=> ($parent_id) ? $this->u_action . '&amp;action=edit&amp;cat_id=' . $parent_id : '',
			'U_DELETE'			=> ($parent_id) ? $this->u_action . '&amp;action=delete&amp;cat_id=' . $parent_id : '',
		));
	}

	function create_cat()
	{
		global $db, $user, $auth, $template, $cache;
		global $config, $phpbb_admin_path, $phpbb_root_path, $phpEx;

		include($phpbb_root_path . 'includes/message_parser.' . $phpEx);
		$submit = (isset($_POST['submit'])) ? true : false;

		add_form_key('create_shop_cat');

		if($submit)
		{
			if (!check_form_key('create_shop_cat'))
			{
				trigger_error($user->lang['FORM_INVALID'] . adm_back_link($this->u_action), E_USER_WARNING);
			}

			$shop_data = array();
			$shop_data = array(
				'cat_name'						=> request_var('cat_name', '', true),
				'parent_id'						=> request_var('parent_id', 0),

				'cat_parents'					=> '',
				'cat_desc'						=>  utf8_normalize_nfc(request_var('cat_desc', '', true)),
				'cat_desc_options'				=> 7,
			);
			generate_text_for_storage($shop_data['cat_desc'], $shop_data['cat_desc_uid'], $shop_data['cat_desc_bitfield'], $shop_data['cat_desc_options'], request_var('desc_parse_bbcode', false), request_var('desc_parse_urls', false), request_var('desc_parse_smilies', false));

			if ($shop_data['parent_id'])
			{
				$sql = 'SELECT left_id, right_id
					FROM ' . SHOP_CATS_TABLE . '
					WHERE cat_id = ' . $shop_data['parent_id'];
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);

				if (!$row)
				{
					trigger_error($user->lang['PARENT_NOT_EXIST'] . adm_back_link($this->u_action . '&amp;' . $this->parent_id), E_USER_WARNING);
				}

				$sql = 'UPDATE ' . SHOP_CATS_TABLE . '
					SET left_id = left_id + 2, right_id = right_id + 2
					WHERE left_id > ' . $row['right_id'];
				$db->sql_query($sql);

				$sql = 'UPDATE ' . SHOP_CATS_TABLE . '
					SET right_id = right_id + 2
					WHERE ' . $row['left_id'] . ' BETWEEN left_id AND right_id';
				$db->sql_query($sql);

				$shop_data['left_id'] = $row['right_id'];
				$shop_data['right_id'] = $row['right_id'] + 1;
			}
			else
			{
				$sql = 'SELECT MAX(right_id) AS right_id
					FROM ' . SHOP_CATS_TABLE;
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);

				$shop_data['left_id'] = $row['right_id'] + 1;
				$shop_data['right_id'] = $row['right_id'] + 2;
			}
			$db->sql_query('INSERT INTO ' . SHOP_CATS_TABLE . ' ' . $db->sql_build_array('INSERT', $shop_data));
			$cache->destroy('sql', SHOP_CATS_TABLE);

			add_log('admin', 'LOG_SHOP_CAT_ADDED', $shop_data['cat_name']);
			trigger_error($user->lang['ACP_SHOP_CAT_NEW_DONE'] . adm_back_link($this->u_action . '&amp;parent_id=' . $shop_data['parent_id']));
		}

		$parent_options = $this->make_cat_select(request_var('parent_id', 0), false, false, false, false);

		$template->assign_vars(array(
			'S_MODE_CREATE_CAT'				=> true,

			'S_ACTION'					=> $this->u_action . '&amp;parent_id=' . request_var('parent_id', 0),
			'S_DESC_BBCODE_CHECKED'		=> true,
			'S_DESC_SMILIES_CHECKED'	=> true,
			'S_DESC_URLS_CHECKED'		=> true,
			'S_PARENT_OPTIONS'			=> $parent_options,
		));
	}

	function edit_cat()
	{
		global $db, $user, $auth, $template, $cache;
		global $config, $phpbb_admin_path, $phpbb_root_path, $phpEx;

		include($phpbb_root_path . 'includes/message_parser.' . $phpEx);

		if (!$cat_id = request_var('cat_id', 0))
		{
			trigger_error('No Cat ID', E_USER_WARNING);
		}

		add_form_key('edit_shop_cat');

		$submit = (isset($_POST['submit'])) ? true : false;
		if($submit)
		{
			if (!check_form_key('edit_shop_cat'))
			{
				trigger_error($user->lang['FORM_INVALID'] . adm_back_link($this->u_action), E_USER_WARNING);
			}

			$shop_data = array();
			$shop_data = array(
				'cat_name'						=> request_var('cat_name', '', true),
				'parent_id'						=> request_var('parent_id', 0),

				'cat_parents'					=> '',
				'cat_desc_options'				=> 7,
				'cat_desc'						=> utf8_normalize_nfc(request_var('cat_desc', '', true)),
			);

			generate_text_for_storage($shop_data['cat_desc'], $shop_data['cat_desc_uid'], $shop_data['cat_desc_bitfield'], $shop_data['cat_desc_options'], request_var('desc_parse_bbcode', false), request_var('desc_parse_urls', false), request_var('desc_parse_smilies', false));
			$row = $this->get_cat_info($cat_id);

			if ($row['parent_id'] != $shop_data['parent_id'])
			{
				//how many do we have to move and how far
				$moving_ids = ($row['right_id'] - $row['left_id']) + 1;
				$sql = 'SELECT MAX(right_id) AS right_id
					FROM ' . SHOP_CATS_TABLE;
				$result = $db->sql_query($sql);
				$highest = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);
				$moving_distance = ($highest['right_id'] - $row['left_id']) + 1;
				$stop_updating = $moving_distance + $row['left_id'];

				//update the moving shop cats ... move it to the end
				$sql = 'UPDATE ' . SHOP_CATS_TABLE . '
					SET right_id = right_id + ' . $moving_distance . ',
						left_id = left_id + ' . $moving_distance . '
					WHERE left_id >= ' . $row['left_id'] . '
						AND right_id <= ' . $row['right_id'];
				$db->sql_query($sql);
				$new['left_id'] = $row['left_id'] + $moving_distance;
				$new['right_id'] = $row['right_id'] + $moving_distance;

				//close the gap, we got
				if ($shop_data['parent_id'] == 0)
				{//we move to root
					//left_id
					$sql = 'UPDATE ' . SHOP_CATS_TABLE . '
						SET left_id = left_id - ' . $moving_ids . '
						WHERE left_id >= ' . $row['left_id'];
					$db->sql_query($sql);
					//right_id
					$sql = 'UPDATE ' . SHOP_CATS_TABLE . '
						SET right_id = right_id - ' . $moving_ids . '
						WHERE right_id >= ' . $row['left_id'];
					$db->sql_query($sql);
				}
				else
				{
					//close the gap
					//left_id
					$sql = 'UPDATE ' . SHOP_CATS_TABLE . '
						SET left_id = left_id - ' . $moving_ids . '
						WHERE left_id >= ' . $row['left_id'] . '
							AND right_id <= ' . $stop_updating;
					$db->sql_query($sql);
					//right_id
					$sql = 'UPDATE ' . SHOP_CATS_TABLE . '
						SET right_id = right_id - ' . $moving_ids . '
						WHERE right_id >= ' . $row['left_id'] . '
							AND right_id <= ' . $stop_updating;
					$db->sql_query($sql);

					//create new gap
					//need parent_information
					$parent = $this->get_cat_info($shop_data['parent_id']);
					//left_id
					$sql = 'UPDATE ' . SHOP_CATS_TABLE . '
						SET left_id = left_id + ' . $moving_ids . '
						WHERE left_id >= ' . $parent['right_id'] . '
							AND right_id <= ' . $stop_updating;
					$db->sql_query($sql);
					//right_id
					$sql = 'UPDATE ' . SHOP_CATS_TABLE . '
						SET right_id = right_id + ' . $moving_ids . '
						WHERE right_id >= ' . $parent['right_id'] . '
							AND right_id <= ' . $stop_updating;
					$db->sql_query($sql);

					//close the gap again
					//new parent right_id!!!
					$parent['right_id'] = $parent['right_id'] + $moving_ids;
					$move_back = ($new['right_id'] - $parent['right_id']) + 1;
					$sql = 'UPDATE ' . SHOP_CATS_TABLE . '
						SET left_id = left_id - ' . $move_back . ',
							right_id = right_id - ' . $move_back . '
						WHERE left_id >= ' . $stop_updating;
					$db->sql_query($sql);
				}
			}
			if ($row['cat_name'] != $shop_data['cat_name'])
			{
				// the forum name has changed, clear the parents list of all forums (for safety)
				$sql = 'UPDATE ' . SHOP_CATS_TABLE . "
					SET cat_parents = ''";
				$db->sql_query($sql);
			}
			$sql = 'UPDATE ' . SHOP_CATS_TABLE . '
					SET ' . $db->sql_build_array('UPDATE', $shop_data) . '
					WHERE cat_id  = ' . (int) $cat_id;
			$db->sql_query($sql);
			$cache->destroy('sql', SHOP_CATS_TABLE);

			add_log('admin', 'LOG_SHOP_CAT_UPDATED', $shop_data['cat_name']);
			trigger_error($user->lang['ACP_SHOP_CAT_EDIT_DONE'] . adm_back_link($this->u_action . '&amp;parent_id=' . $shop_data['parent_id']));
		}
		$sql = 'SELECT *
			FROM ' . SHOP_CATS_TABLE . "
			WHERE cat_id = '$cat_id'";
		$result = $db->sql_query($sql);
		if ($db->sql_affectedrows($result) == 0)
		{
			trigger_error('The requested cat does not exist', E_USER_WARNING);
		}
		$shop_data = $db->sql_fetchrow($result);
		$shop_desc_data = generate_text_for_edit($shop_data['cat_desc'], $shop_data['cat_desc_uid'], $shop_data['cat_desc_options']);
		$parents_list = $this->make_cat_select($shop_data['parent_id'], $cat_id);

		$template->assign_vars(array(
			'S_MODE_EDIT_CAT'				=> true,

			'S_ACTION'					=> $this->u_action . '&amp;action=edit&amp;cat_id=' . $cat_id,
			'S_PARENT_OPTIONS'			=> $parents_list,

			'CAT_NAME'					=> $shop_data['cat_name'],
			'CAT_DESC'					=> $shop_desc_data['text'],
			'S_DESC_BBCODE_CHECKED'		=> ($shop_desc_data['allow_bbcode']) ? true : false,
			'S_DESC_SMILIES_CHECKED'	=> ($shop_desc_data['allow_smilies']) ? true : false,
			'S_DESC_URLS_CHECKED'		=> ($shop_desc_data['allow_urls']) ? true : false,

			'S_MODE'					=> 'edit',
		));
	}

	function delete_cat()
	{
		global $db, $template, $user, $cache;

		if (!$cat_id = request_var('cat_id', 0))
		{
			trigger_error('No Cat ID', E_USER_WARNING);
		}
		else
		{
			$sql = 'SELECT *
				FROM ' . SHOP_CATS_TABLE . "
				WHERE cat_id = '$cat_id'";
			$result = $db->sql_query($sql);
			if ($db->sql_affectedrows($result) == 0)
			{
				trigger_error($user->lang['ACP_SHOP_CAT_NOT_EXISTS'], E_USER_WARNING);
			}
		}

		if (confirm_box(true))
		{
			$shop = $this->get_cat_info($cat_id);
			$handle_subs = request_var('handle_subs', 0);
			if (($shop['right_id'] - $shop['left_id']) > 2)
			{//handle subs if there
				//we have to learn how to delete or move the subs
				if ($handle_subs >= 0)
				{
					trigger_error($user->lang['ACP_SHOP_DELETE_SUB_CATS'] . adm_back_link($this->u_action), E_USER_WARNING);
				}
			}

			// Check if category has files
			$sql = ' SELECT COUNT(item) AS has_items
				FROM ' . SHOP_ITEMS_TABLE . '
				WHERE shop_cat_id = ' . $cat_id;
			$result = $db->sql_query($sql);
			$row = $db->sql_fetchrow($result);
			$has_items = $row['has_items'];
			$db->sql_freeresult($result);

			if ( $has_items > 0 )
			{
				trigger_error($user->lang['ACP_SHOP_DELETE_HAS_FILES'] . adm_back_link($this->u_action), E_USER_WARNING);
			}

			// Get cat name
			$sql = 'SELECT cat_name
				FROM ' . SHOP_CATS_TABLE . "
				WHERE cat_id = '$cat_id'";
			$result = $db->sql_query($sql);
			$row = $db->sql_fetchrow($result);
			$shop_cat_name = $row['cat_name'];
			$db->sql_freeresult($result);

			//reorder the other items
			//left_id
			$sql = 'UPDATE ' . SHOP_CATS_TABLE . '
				SET left_id = left_id - 2
				WHERE left_id > ' . $shop['left_id'];
			$db->sql_query($sql);
			//right_id
			$sql = 'UPDATE ' . SHOP_CATS_TABLE . '
				SET right_id = right_id - 2
				WHERE right_id > ' . $shop['left_id'];
			$db->sql_query($sql);
			$sql = 'DELETE FROM ' . SHOP_CATS_TABLE . "
				WHERE cat_id = '$cat_id'";
			$result = $db->sql_query($sql);
			$cache->destroy('sql', SHOP_CATS_TABLE);

			add_log('admin', 'LOG_SHOP_CAT_DELETED', $shop_cat_name);
			trigger_error($user->lang['ACP_SHOP_CAT_DELETE_DONE'] . adm_back_link($this->u_action));

			$catname = '';
			$sql = 'SELECT ec.*, COUNT(ed.shop_cat_id) AS items
				FROM ' . SHOP_CATS_TABLE . ' AS ec
				LEFT JOIN ' . SHOP_ITEMS_TABLE . ' AS ed
					ON ec.cat_id = ed.shop_cat_id
				WHERE ec.cat_id = ' . $cat_id . '
				GROUP BY ec.cat_id';
			$result = $db->sql_query($sql);

			$subs_found = false;
			while($row = $db->sql_fetchrow($result))
			{
				if($row['cat_id'] == $cat_id)
				{
					$thisshop = $row;
					$subs_found = true;
				}
				else
				{
					$shoprow[] = $row;
				}
			}

			if(!$subs_found)
			{
				trigger_error($user->lang['ACP_SHOP_CAT_NOT_EXISTS'], E_USER_WARNING);
			}
			$db->sql_freeresult($result);

			$template->assign_vars(array(
				'S_MODE_DELETE_CAT'		=> true,

				'S_SHOP_ACTION'				=> $this->u_action . '&amp;action=delete&amp;shop_id=' . $cat_id,
				'SHOP_DELETE'				=> sprintf($user->lang['ACP_SHOP_REALLY_DELETE'], $row['cat_name']),
				'S_PARENT_OPTIONS'			=> $this->make_cat_select($thisshop['parent_id'], $cat_id),
				'S_HAS_CHILDREN'			=> ($thisshop['left_id'] + 1 != $thisshop['right_id']) ? true : false,
				'S_HAS_BUGS'				=> ($thisshop['items'] > 0) ? true : false,
				'CAT_NAME'					=> $thisshop['cat_name'],
				'SHOP_DESC'					=> generate_text_for_display($thisshop['cat_desc'], $thisshop['cat_desc_uid'], $thisshop['cat_desc_bitfield'], $thisshop['cat_desc_options']),
				'S_MOVE_SHOP_OPTIONS'		=> $this->make_cat_select(false, $cat_id),
				'S_MOVE_IMAGE_OPTIONS'		=> $this->make_cat_select(false, $cat_id, true),
			));
		}
		else
		{
			$confirm_string = sprintf($user->lang['ACP_SHOP_REALLY_DELETE']);
			confirm_box(false, $confirm_string);
		}
		redirect($this->u_action);
	}

	function move_cat()
	{
		global $db, $user, $cache;

		if (!$cat_id = request_var('cat_id', 0))
		{
			trigger_error('No Cat ID', E_USER_WARNING);
		}
		else
		{
			$sql = 'SELECT *
				FROM ' . SHOP_CATS_TABLE . "
				WHERE cat_id = '$cat_id'";
			$result = $db->sql_query($sql);
			if ($db->sql_affectedrows($result) == 0)
			{
				trigger_error('The requested category does not exist', E_USER_WARNING);
			}
		}
		$move = request_var('move', '', true);
		$moving = $this->get_cat_info($cat_id);

		$sql = 'SELECT cat_id, left_id, right_id
			FROM ' . SHOP_CATS_TABLE . "
			WHERE parent_id = {$moving['parent_id']}
				AND " . (($move == 'move_up') ? "right_id < {$moving['right_id']} ORDER BY right_id DESC" : "left_id > {$moving['left_id']} ORDER BY left_id ASC");
		$result = $db->sql_query_limit($sql, 1);

		$target = array();
		while ($row = $db->sql_fetchrow($result))
		{
			$target = $row;
		}
		$db->sql_freeresult($result);

		if (!sizeof($target))
		{
			// The forum is already on top or bottom
			return false;
		}

		if ($move == 'move_up')
		{
			$left_id = $target['left_id'];
			$right_id = $moving['right_id'];

			$diff_up = $moving['left_id'] - $target['left_id'];
			$diff_down = $moving['right_id'] + 1 - $moving['left_id'];

			$move_up_left = $moving['left_id'];
			$move_up_right = $moving['right_id'];
		}
		else
		{
			$left_id = $moving['left_id'];
			$right_id = $target['right_id'];

			$diff_up = $moving['right_id'] + 1 - $moving['left_id'];
			$diff_down = $target['right_id'] - $moving['right_id'];

			$move_up_left = $moving['right_id'] + 1;
			$move_up_right = $target['right_id'];
		}

		// Now do the dirty job
		$sql = 'UPDATE ' . SHOP_CATS_TABLE . "
			SET left_id = left_id + CASE
				WHEN left_id BETWEEN {$move_up_left} AND {$move_up_right} THEN -{$diff_up}
				ELSE {$diff_down}
			END,
			right_id = right_id + CASE
				WHEN right_id BETWEEN {$move_up_left} AND {$move_up_right} THEN -{$diff_up}
				ELSE {$diff_down}
			END,
			cat_parents = ''
			WHERE
				left_id BETWEEN {$left_id} AND {$right_id}
				AND right_id BETWEEN {$left_id} AND {$right_id}";
		$db->sql_query($sql);
		$cache->destroy('sql', SHOP_CATS_TABLE);
		redirect($this->u_action . '&amp;parent_id=' . $moving['parent_id']);
	}

	// Create the select categories list
	function make_cat_select($select_id = false, $ignore_id = false, $shop = false, $ignore_acl = false, $ignore_nonpost = false, $ignore_emptycat = true, $only_acl_post = false, $return_array = false)
	{
		global $db, $user, $auth;

		// No permissions yet
		$acl = ($ignore_acl) ? '' : (($only_acl_post) ? 'f_post' : array('f_list', 'a_forum', 'a_forumadd', 'a_forumdel'));

		// This query is the same as the jumpbox query
		$sql = 'SELECT cat_id, cat_name, parent_id, left_id, right_id
			FROM ' . SHOP_CATS_TABLE . '
			ORDER BY left_id ASC';
		$result = $db->sql_query($sql, 600);

		$right = 0;
		$padding_store = array('0' => '');
		$padding = '';
		$forum_list = ($return_array) ? array() : '';

		//----------------------------------------------------------------------------------------
		// Sometimes it could happen that forums will be displayed here not be displayed within the index page
		// This is the result of forums not displayed at index, having list permissions and a parent of a forum with no permissions.
		// If this happens, the padding could be "broken"
		//----------------------------------------------------------------------------------------

		while ($row = $db->sql_fetchrow($result))
		{
			if ($row['left_id'] < $right)
			{
				$padding .= '&nbsp; &nbsp;';
				$padding_store[$row['parent_id']] = $padding;
			}
			else if ($row['left_id'] > $right + 1)
			{
				$padding = (isset($padding_store[$row['parent_id']])) ? $padding_store[$row['parent_id']] : '';
			}

			$right = $row['right_id'];
			$disabled = false;

			if (((is_array($ignore_id) && in_array($row['cat_id'], $ignore_id)) || $row['cat_id'] == $ignore_id) || ($shop))
			{
				$disabled = true;
			}

			if ($return_array)
			{
				$selected = (is_array($select_id)) ? ((in_array($row['cat_id'], $select_id)) ? true : false) : (($row['cat_id'] == $select_id) ? true : false);
				$forum_list[$row['cat_id']] = array_merge(array('padding' => $padding, 'selected' => ($selected && !$disabled), 'disabled' => $disabled), $row);
			}
			else
			{
				$selected = (is_array($select_id)) ? ((in_array($row['cat_id'], $select_id)) ? ' selected="selected"' : '') : (($row['cat_id'] == $select_id) ? ' selected="selected"' : '');
				$forum_list .= '<option value="' . $row['cat_id'] . '"' . (($disabled) ? ' disabled="disabled" class="disabled-option"' : $selected) . '>' . $padding . $row['cat_name'] . '</option>';
			}
		}
		$db->sql_freeresult($result);
		unset($padding_store);

		return $forum_list;
	}

	// Get the category details
	function get_cat_info($cat_id)
	{
		global $db;

		$sql = 'SELECT *
			FROM ' . SHOP_CATS_TABLE . "
			WHERE cat_id = $cat_id";
		$result = $db->sql_query($sql);
		$row = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);

		if (!$row)
		{
			trigger_error("Cat #$cat_id does not exist", E_USER_ERROR);
		}

		return $row;
	}

	// Get the category branch
	function get_cat_branch($cat_id, $type = 'all', $order = 'descending', $include_cat = true)
	{
		global $db;

		switch ($type)
		{
			case 'parents':
				$condition = 'a1.left_id BETWEEN a2.left_id AND a2.right_id';
			break;

			case 'children':
				$condition = 'a2.left_id BETWEEN a1.left_id AND a1.right_id';
			break;

			default:
				$condition = 'a2.left_id BETWEEN a1.left_id AND a1.right_id OR a1.left_id BETWEEN a2.left_id AND a2.right_id';
			break;
		}

		$rows = array();

		$sql = 'SELECT a2.*
			FROM ' . SHOP_CATS_TABLE . ' a1
			LEFT JOIN ' . SHOP_CATS_TABLE . " a2 ON ($condition)
			WHERE a1.cat_id = $cat_id
			ORDER BY a2.left_id " . (($order == 'descending') ? 'ASC' : 'DESC');
		$result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result))
		{
			if (!$include_cat && $row['cat_id'] == $cat_id)
			{
				continue;
			}

			$rows[] = $row;
		}
		$db->sql_freeresult($result);

		return $rows;
	}

}

// Create the select categories list
function make_cat_select($select_id = false, $ignore_id = false, $dm_video = false, $ignore_acl = false, $ignore_nonpost = false, $ignore_emptycat = true, $only_acl_post = false, $return_array = false)
{
	global $db, $user, $auth;

	// No permissions yet
	$acl = ($ignore_acl) ? '' : (($only_acl_post) ? 'f_post' : array('f_list', 'a_forum', 'a_forumadd', 'a_forumdel'));

	// This query is the same as the jumpbox query
	$sql = 'SELECT cat_id, cat_name, parent_id, left_id, right_id
		FROM ' . SHOP_CATS_TABLE . '
		ORDER BY left_id ASC';
	$result = $db->sql_query($sql, 600);

	$right = 0;
	$padding_store = array('0' => '');
	$padding = '';
	$forum_list = ($return_array) ? array() : '';

	//----------------------------------------------------------------------------------------
	// Sometimes it could happen that forums will be displayed here not be displayed within the index page
	// This is the result of forums not displayed at index, having list permissions and a parent of a forum with no permissions.
	// If this happens, the padding could be "broken"
	//----------------------------------------------------------------------------------------

	while ($row = $db->sql_fetchrow($result))
	{
		if ($row['left_id'] < $right)
		{
			$padding .= '&nbsp; &nbsp;';
			$padding_store[$row['parent_id']] = $padding;
		}
		else if ($row['left_id'] > $right + 1)
		{
			$padding = (isset($padding_store[$row['parent_id']])) ? $padding_store[$row['parent_id']] : '';
		}

		$right = $row['right_id'];
		$disabled = false;

		if (((is_array($ignore_id) && in_array($row['cat_id'], $ignore_id)) || $row['cat_id'] == $ignore_id) || ($shop))
		{
			$disabled = true;
		}

		if ($return_array)
		{
			$selected = (is_array($select_id)) ? ((in_array($row['cat_id'], $select_id)) ? true : false) : (($row['cat_id'] == $select_id) ? true : false);
			$forum_list[$row['cat_id']] = array_merge(array('padding' => $padding, 'selected' => ($selected && !$disabled), 'disabled' => $disabled), $row);
		}
		else
		{
			$selected = (is_array($select_id)) ? ((in_array($row['cat_id'], $select_id)) ? ' selected="selected"' : '') : (($row['cat_id'] == $select_id) ? ' selected="selected"' : '');
			$forum_list .= '<option value="' . $row['cat_id'] . '"' . (($disabled) ? ' disabled="disabled" class="disabled-option"' : $selected) . '>' . $padding . $row['cat_name'] . '</option>';
		}
	}
	$db->sql_freeresult($result);
	unset($padding_store);

	return $forum_list;
}

// Get the category details
function get_cat_info($cat_id)
{
	global $db;

	$sql = 'SELECT *
		FROM ' . SHOP_CATS_TABLE . "
		WHERE cat_id = $cat_id";
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);

	if (!$row)
	{
		trigger_error("Cat #$cat_id does not exist", E_USER_ERROR);
	}

	return $row;
}

// Get the category branch
function get_cat_branch($cat_id, $type = 'all', $order = 'descending', $include_cat = true)
{
	global $db;

	switch ($type)
	{
		case 'parents':
			$condition = 'a1.left_id BETWEEN a2.left_id AND a2.right_id';
		break;

		case 'children':
			$condition = 'a2.left_id BETWEEN a1.left_id AND a1.right_id';
		break;

		default:
			$condition = 'a2.left_id BETWEEN a1.left_id AND a1.right_id OR a1.left_id BETWEEN a2.left_id AND a2.right_id';
		break;
	}

	$rows = array();

	$sql = 'SELECT a2.*
		FROM ' . SHOP_CATS_TABLE . ' a1
		LEFT JOIN ' . SHOP_CATS_TABLE . " a2 ON ($condition)
		WHERE a1.cat_id = $cat_id
		ORDER BY a2.left_id " . (($order == 'descending') ? 'ASC' : 'DESC');
	$result = $db->sql_query($sql);

	while ($row = $db->sql_fetchrow($result))
	{
		if (!$include_cat && $row['cat_id'] == $cat_id)
		{
			continue;
		}

		$rows[] = $row;
	}
	$db->sql_freeresult($result);

	return $rows;
}

?>