<?php
/**
*
* @package - phpbb3 UPS Easy Shop
* @version $Id: ucp_shop.php 254 2010-08-24 20:31:07Z Wuerzi $
* @copyright (c) Wuerzi (http://spieleresidenz.de), (c) femu (http://die-muellers.org)
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class ucp_shop
{
	var $u_action;

	function main($id, $mode)
	{
		global $db, $user, $auth, $template, $shop, $shop_config;
		global $config, $phpbb_root_path, $phpbb_admin_path, $phpEx;

		$user->add_lang('mods/shop');
		$user->add_lang('mods/points');

		add_form_key('shop_ucp');

		// Check if Shop is enabled
		if (!$config['shop_enable'])
		{
			trigger_error($shop_config['disable_message']);
		}

		// Check if you are locked or not
		if (!$auth->acl_get('u_shop_mod'))
		{
			trigger_error('NOT_AUTHORISED');
		}

		switch ($mode)
		{
			case 'config':
				require($phpbb_root_path . 'includes/shop/functions_shop.' . $phpEx);

				$sql = 'SELECT *
					FROM ' . SHOP_CONFIG_USER_TABLE . '
					WHERE user_id = ' . (int) $user->data['user_id'];
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);

				$template->assign_vars(array(
					'S_ALLOW_PM'		=> $row['shop_pm_user'],
					'S_ALLOW_DISPLAY'	=> $row['shop_shelf_display'],
					'U_UCP_ACTION'		=> $this->u_action,
					'S_SUBMIT'			=> $this->u_action,
				));

				if ( isset($_POST['submit']) )
				{
					if (!check_form_key('shop_ucp'))
					{
						trigger_error('FORM_INVALID');
					}

					$sql_ary = array(
						'user_id'				=> $user->data['user_id'],
						'shop_pm_user'			=> request_var('shoppm', 0),
						'shop_shelf_display'	=> request_var('display', 0),
					);

					if (!$row)
					{
						$sql = 'INSERT INTO ' . SHOP_CONFIG_USER_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_ary);
						$db->sql_query($sql);
					}
					else
					{
						$sql = 'UPDATE ' . SHOP_CONFIG_USER_TABLE . '
							SET ' . $db->sql_build_array('UPDATE', $sql_ary) . '
							WHERE user_id = ' . $user->data['user_id'];
						$db->sql_query($sql);
					}

					meta_refresh(3, $this->u_action);
					$message = $user->lang['UCP_SHOP_SETTINGS_UPDATED'] . '<br /><br />' . sprintf($user->lang['RETURN_UCP'], '<a href="' . $this->u_action . '">', '</a>');
					trigger_error($message);
				}

			break;

			case 'inventory':

				// Get us our ever-important shop object
				require($phpbb_root_path . 'includes/shop/functions_shop.' . $phpEx);
				$shop = new shop;

				if (($action = request_var('action','list')) != 'list')
				{
					global $shop;

					$item_id = request_var('item',0);

					if (!$item = $shop->get_item_user($item_id))
					{
						trigger_error('SHOP_ITEM_ID_NOT_FOUND');
					}

					if ($message = $item->action_handler($action))
					{
						meta_refresh(3, $this->u_action);
						$message = $message . '<br /><br />' . sprintf($user->lang['RETURN_UCP'], '<a href="' . $this->u_action . '">', '</a>');
						trigger_error($message);
					}
					else
					{
						redirect($this->u_action);
					}
				}

				if ($items = $shop->get_item_list_ucp())
				{
					foreach($items as $item)
					{
						$icon_show_width = $icon_show_height = 0;

						// Define image size and scale ratio
						// Code partly from Michael Bailey
						$orig_width = $item->data['icon_width'];
						$orig_height = $item->data['icon_height'];
						$scale = min($shop_config['shop_icon_width']/$orig_width, $shop_config['shop_icon_height']/$orig_height);

						// If the image is larger than the max shrink it
						if ($scale < 1)
						{
							$icon_show_width = floor($scale*$orig_width);
							$icon_show_height = floor($scale*$orig_height);
						}
						else
						{
							$icon_show_width = $orig_width;
							$icon_show_height = $orig_height;
						}

						// Check if Highslide JS is installed
						if (file_exists($phpbb_root_path . 'highslide/highslide-full.js'))
						{
							$show_icon = '<a href="' . $phpbb_root_path . 'images/shop_icons/' . $item->data['icon'] . '" class="highslide" onclick="return hs.expand(this)" title="' . $user->lang['SHOP_HIGHSLIDE_CLICK'] . '"><img src="' . $phpbb_root_path . 'images/shop_icons/' . $item->data['icon'] . '" width="' . $icon_show_width . '" height="' . $icon_show_height . '" alt="' . $user->lang['SHOP_HIGHSLIDE_CLICK'] . '" /></a>';
						}
						else
						{
							$show_icon = '<a href="' . $phpbb_root_path . 'images/shop_icons/' . $item->data['icon'] . '" onclick=" window.open(this.href); return false" title="' . $user->lang['SHOP_HIGHSLIDE_CLICK'] . '"><img src="' . $phpbb_root_path . 'images/shop_icons/' . $item->data['icon'] . '" width="' . $icon_show_width . '" height="' . $icon_show_height . '" alt="' . $user->lang['SHOP_HIGHSLIDE_CLICK'] . '" /></a>';
						}

						// Pagination Items
						$start			= request_var('start', 0);
						$number			= $shop_config['items_per_page'];
						$user_id 		= $user->data['user_id'];

						$sql = 'SELECT COUNT(item) AS total_items
							FROM ' . SHOP_ITEMS_USER_TABLE . '
							WHERE user = ' . (int) $user_id;
						$result = $db->sql_query($sql);
						$row = $db->sql_fetchrow($result);
						$total_items = $row['total_items'];
						$db->sql_freeresult($result);

						if ($item->data['sell_to_price'] == 0)
						{
							$sell_to_price = $user->lang['UCP_SHOP_NO_SALE'];
						}
						else
						{
							$sell_to_price = $item->data['sell_to_price'];
						}

						$template->assign_block_vars('item_list', array(
							'NAME'			=> $item->data['name'],
							'ICON'			=> $show_icon,
							'QUANTITY'		=> $item->data['quantity_user'],
							'SELL_TO_PRICE'	=> $sell_to_price,
							'POINTS_NAME'	=> $config['points_name'],
						));

						$template->assign_vars(array(
							'PAGINATION' 		=> generate_pagination($this->u_action, $total_items, $number, $start, true),
							'PAGE_NUMBER'		=> on_page($total_items, $number, $start),
							'TOTAL_USER_ITEMS'	=> sprintf($user->lang['SHOP_TOTAL_USER_ITEMS'], $total_items),
						));

						foreach($item->get_actions() as $action_name => $action)
						{
							$template->assign_block_vars('item_list.actions', array(
								'ACTION_NAME'	=> $action['name'],
								'U_ACTION'		=> ($action['function'] == 'none') ? false : $this->u_action . '&amp;' . "action=$action_name&amp;item={$item->data['item_user']}"
							));
						}
					}
				}

				$template->assign_vars(array(
					'POINTS_NAME'	=> sprintf($user->lang['UCP_SHOP_IN_POINTS'], $config['points_name']),
				));
			break;

			case 'sell':

				require($phpbb_root_path . 'includes/shop/functions_shop.' . $phpEx);

				// Check, if user has items
				$sql = 'SELECT COUNT(item) AS num
					FROM ' . SHOP_ITEMS_USER_TABLE . '
					WHERE user = ' . (int) $user->data['user_id'];
				$result = $db->sql_query($sql);
				$total_items = (int) $db->sql_fetchfield('num');

				if ($total_items == 0)
				{
					$template->assign_vars(array(
						'S_NO_ITEMS'	=> true,
					));
				}
				else
				{
					$default_item = $sell_to_price = '';
					$user_have_items = '<option value="0; " selected="selected">' . sprintf($user->lang['SELECT']) . '</option>';

					$sql = 'SELECT ui.item, ui.sell_to_price, i.name
						FROM ' . SHOP_ITEMS_USER_TABLE . ' ui
						LEFT JOIN ' . SHOP_ITEMS_TABLE . ' i
							ON ui.item = i.item
						WHERE ui.user = ' . (int) $user->data['user_id'] . '
						ORDER BY i.name ASC';
					$result = $db->sql_query($sql);

					while ($row = $db->sql_fetchrow($result))
					{
						$user_have_items .= '<option value="' . $row['item'] . ';' .  $row['sell_to_price'] .  '">' . $row['name'] . '</option>';
					}
					$db->sql_freeresult($result);

					$template->assign_vars(array(
						'S_FORMSELF'	=> append_sid("{$phpbb_root_path}ucp.$phpEx", "i=shop&amp;mode=sell"),
						'ITEM'			=> $row['name'],
						'PRICE'			=> $row['sell_to_price'],
						'USER_ITEMS'	=> $user_have_items,
						'SELL_TO_PRICE'	=> $sell_to_price,
						'POINTS_NAME'	=> $config['points_name'],
					));

					if ( isset($_POST['submit']) )
					{
						if (!check_form_key('shop_ucp'))
						{
							trigger_error('FORM_INVALID');
						}

						// Grab need variables
						$selected_item 	= request_var('item', '');
						$sell_to_price	= request_var('sell_to_price', 0.00);

						// Update the selling price in the users inventory
						$sql = 'UPDATE ' . SHOP_ITEMS_USER_TABLE . '
							SET sell_to_price = ' . $sell_to_price . '
							WHERE item = ' . (int) $selected_item . '
								AND user = ' . (int) $user->data['user_id'];
						$db->sql_query($sql);

						$information = $user->lang['UCP_SHOP_SELL_PRICE_UPDATED'];

						$message = $information . '<br /><br />' . sprintf($user->lang['RETURN_UCP'], '<a href="' . $this->u_action . '">', '</a>');
						trigger_error($message);
					}
				}
			break;

			case 'present':

				require($phpbb_root_path . 'includes/shop/functions_shop.' . $phpEx);
				include($phpbb_root_path . 'includes/functions_privmsgs.' . $phpEx);

				// Check, if user has items
				$sql = 'SELECT COUNT(item) AS num
					FROM ' . SHOP_ITEMS_USER_TABLE . '
					WHERE user = ' . (int) $user->data['user_id'];
				$result = $db->sql_query($sql);
				$total_items = (int) $db->sql_fetchfield('num');

				if ($total_items == 0)
				{
					$template->assign_vars(array(
						'S_NO_ITEMS'	=> true,
					));
				}
				else
				{

					$user_have_items = '';
					$sql = 'SELECT ui.item, i.name
						FROM ' . SHOP_ITEMS_USER_TABLE . ' ui
						LEFT JOIN ' . SHOP_ITEMS_TABLE . ' i
							ON ui.item = i.item
						WHERE ui.user = ' . (int) $user->data['user_id'] . '
						ORDER BY i.name ASC';
					$result = $db->sql_query($sql);

					while ($row = $db->sql_fetchrow($result))
					{
						$selected = ( $row['item'] == $row['item'] ) ? ' selected="selected"' : '';
						$user_have_items .= '<option value="' . $row['item'] . '" ' . $selected . '>' . $row['name'] . '</option>';
					}
					$db->sql_freeresult($result);

					// Generate possible items combobox
					$items_combo 	= '<select name="item">';
					$items_combo	.= $user_have_items;
					$items_combo	.= '</select>';

					$template->assign_vars(array(
						'USER_ITEMS'	=> $items_combo,
					));

					if ( isset($_POST['submit']) )
					{
						if (!check_form_key('shop_ucp'))
						{
							trigger_error('FORM_INVALID');
						}

						// Grab need variables for the transfer
						$selected_item = request_var('item', '');
						$username1 	= request_var('username', '', true);
						$username 	= strtolower($username1);

						// Select the user data to transfer to
						$sql_array = array(
							'SELECT'    => '*',
							'FROM'      => array(
								USERS_TABLE => 'u',
							),
							'WHERE'		=> 'username_clean = "' . $db->sql_escape(utf8_clean_string($username)) . '"',
						);
						$sql = $db->sql_build_query('SELECT', $sql_array);
						$result = $db->sql_query($sql);
						$transfer_user = $db->sql_fetchrow($result);

						$transfer_user_id = $transfer_user['user_id'];
						$transfer_user_name = $transfer_user['username'];

						$db->sql_freeresult($result);

						if ($transfer_user == NULL)
						{
							$message = $user->lang['SHOP_TRANSFER_NO_USER_RETURN'] . '<br /><br /><a href="' . append_sid("{$phpbb_root_path}ucp.$phpEx", "i=shop&amp;mode=present") . '">&laquo; ' . $user->lang['SHOP_BACK_TO_PREV'] . '</a>';
							trigger_error($message);
						}

						// Check, if user is trying to send to himself
						if ($user->data['user_id'] == $transfer_user['user_id'])
						{
							$message = $user->lang['SHOP_TRANSFER_REASON_YOURSELF'] . '<br /><br /><a href="' . append_sid("{$phpbb_root_path}ucp.$phpEx", "i=shop&amp;mode=present") . '">&laquo; ' . $user->lang['SHOP_BACK_TO_PREV'] . '</a>';
							trigger_error($message);
						}

						// Remove item from users shelf
						$sql = 'UPDATE ' . SHOP_ITEMS_USER_TABLE . '
							SET quantity_user = quantity_user - 1
							WHERE item = ' . (int) $selected_item . '
								AND user = ' . (int) $user->data['user_id'];
						$db->sql_query($sql);

						$sql = 'DELETE FROM ' . SHOP_ITEMS_USER_TABLE . '
							WHERE quantity_user = 0';
						$db->sql_query($sql);

						// Add item to transfer users shelf
						$sql = 'SELECT COUNT(item) AS num
							FROM ' . SHOP_ITEMS_USER_TABLE . '
							WHERE user = ' . $transfer_user_id . '
								AND item = ' . $selected_item;
						$result = $db->sql_query($sql);
						$transfer_user_items = (int) $db->sql_fetchfield('num');

						if ($transfer_user_items == 0)
						{
							$sql = 'INSERT INTO ' . SHOP_ITEMS_USER_TABLE . ' ' . $db->sql_build_array('INSERT', array(
								'item' => $selected_item,
								'user' => $transfer_user_id,
								'quantity_user' => 1));
							$db->sql_query($sql);
						}
						else
						{
							$sql = 'UPDATE ' . SHOP_ITEMS_USER_TABLE . '
								SET quantity_user = quantity_user + 1
								WHERE item = ' . (int) $selected_item . '
									AND user = ' . (int) $transfer_user_id;
							$db->sql_query($sql);
						}

						// Finally inform the transfer user, that he received a donation

						$sql = 'SELECT name
							FROM ' . SHOP_ITEMS_TABLE . '
							WHERE item =' . (int) $selected_item;
						$result = $db->sql_query($sql);
						$item_name = $db->sql_fetchfield('name');

						// Add Userlog
						if ($shop_config['shop_log_user_activity'] == 1)
						{
							add_log('user', $user->data['user_id'], 'LOG_SHOP_PRESENT_ITEM', $item_name, $transfer_user_name);
						}

						$pm_subject	= utf8_normalize_nfc(sprintf($user->lang['SHOP_TRANSFER_PM_SUBJECT']));
						$pm_text	= utf8_normalize_nfc(sprintf($user->lang['SHOP_TRANSFER_PM_BODY'], $user->data['username'], $item_name));

						$poll = $uid = $bitfield = $options = '';
						generate_text_for_storage($pm_subject, $uid, $bitfield, $options, false, false, false);
						generate_text_for_storage($pm_text, $uid, $bitfield, $options, true, true, true);

						$pm_data = array(
							'address_list'		=> array ('u' => array($transfer_user_id => 'to')),
							'from_user_id'		=> $user->data['user_id'],
							'from_username'		=> $user->data['username'],
							'icon_id'			=> 0,
							'from_user_ip'		=> '',

							'enable_bbcode'		=> true,
							'enable_smilies'	=> true,
							'enable_urls'		=> true,
							'enable_sig'		=> true,

							'message'			=> $pm_text,
							'bbcode_bitfield'	=> $bitfield,
							'bbcode_uid'		=> $uid,
						);

						submit_pm('post', $pm_subject, $pm_data, false);

						$message = sprintf($user->lang['SHOP_TRANSFER_SUCCESS'], $transfer_user_name, $item_name) . '<br /><br /><a href="' . append_sid("{$phpbb_root_path}ucp.$phpEx", "i=shop&amp;mode=present") . '">&laquo; ' . $user->lang['BACK_TO_PREV'] . '</a>';
						trigger_error($message);
					}
				}
			break;
		}

		$template->assign_vars(array(
			'L_TITLE'			=> $user->lang['UCP_SHOP_' . strtoupper($mode)],
			'S_SUBMIT'			=> $this->u_action,
			'U_FIND_USERNAME'	=> append_sid("{$phpbb_root_path}memberlist.$phpEx", "mode=searchuser&amp;form=ucp&amp;field=username"),
			'S_UCP_ACTION'		=> $this->u_action
		));

		// Set desired template
		$this->tpl_name = 'ucp_shop_' . $mode;
		$this->page_title = 'UCP_SHOP_' . strtoupper($mode);

	}
}

?>
